



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PIC32MZ tutorial -- Key Debounce</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PIC32MZ tutorial -- Key Debounce</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 02:35:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　Today I accomplish a application on PIC32MZ EC Starter Kit. The feature of application is to light up LED when key released and put out LED when key pressed. LED is &nbsp;the Starter Kit LED1 connecting to RH0. Key is the Starter Kit push button SW1 connecting to RB12. I also use the Timer1 Interrupt. In my application, I just design the software with three modules -- LED module, KEY module and TIMER1 module and the final is the main function and interrupt service routine.</p>
<p>　　LED module let LED1 on when "LedState" variable is 1, and off when "LedState" variable is 0. Below is its implementation.</p>
<div>
<pre class="prettyprint linenums">#define LED_IOCTL()       TRISHCLR = (1&lt;&lt;0)<br />
#define LED_SETON()       LATHSET = (1&lt;&lt;0)<br />
#define LED_SETOFF()      LATHCLR = (1&lt;&lt;0)<br />
#define LED_ONOFF()       LATHINV = (1&lt;&lt;0)<br />
#define LED_OPEN()        ANSELH &amp;= 0xFFFFFFFE

typedef enum _LED_STATE_t<br />
{<br />
    OFF = ,<br />
    ON =<br />
} LED_STATE_t;

LED_STATE_t PreLedState, LedState;

void Led_Init(void)<br />
{<br />
    LED_OPEN();<br />
    LED_IOCTL();<br />
    LED_SETON();<br />
    LedState = ON;<br />
    PreLedState = LedState;<br />
}

void Led_Scheduler(void)<br />
{<br />
    if (LedState != PreLedState)<br />
    {<br />
        LED_ONOFF();<br />
        PreLedState = LedState;<br />
    }<br />
}</pre>
</div>
<p>　　The "LedState" variable is determined by KEY module. The key press validated, the "LedState" is 1. The key release validated, the "LedState" is 0. Since the key (push button) does not have any debounce circuitry. I enable the internal resistor pull-up and use a debounce algorithm to remove random or spurious transistings of a digital signal read as an input by PIC32MZ. The following example illustrates how this algorithm works. The sequence labeled, corrupted, has significant random transitions added to the real signal. The sequence labled, integrator, represents the algorithm integrator which is constrained to be between 0 and 3. The sequence labeled, output, only makes a transition when the integrator reaches either 0 or 3. Note that the output signal lags the input signal by the integration time but is free of spurious transitions.</p>
<p>real signal　 0000111111110000000111111100000000011111111110000000000111111100000</p>
<p>corrupted　 &nbsp;0100111011011001000011011010001001011100101111000100010111011100010</p>
<p>integrator &nbsp; &nbsp;0100123233233212100012123232101001012321212333210100010123233321010</p>
<p>output　　　 0000001111111111100000001111100000000111111111110000000001111111000</p>
<p>　　The algotithm has been around for many many years but does not seem to be widely known. It is notable that the algotithm uses integration as opposed to edge logic. It is the integration that makes this algotithm so robust in the presence of noise. In the implementation of KEY module, I use "DEBOUNCE_TimeFlag" variable to control debounce start.</p>
<div>
<pre class="prettyprint linenums">#define DEBOUNCE_Input          (PORTB &amp; 0x1000)<br />
#define DEBOUNCE_Open()         ANSELB = 0xFFFFEFFF<br />
#define DEBOUNCE_IOCtl()        CNPUBSET = 0x1000<br />
#define DEBOUNCE_Output         LedState<br />
#define DEBOUNCE_ThreholdLow    0<br />
#define DEBOUNCE_ThreholdHigh   100

unsigned long DEBOUNCE_PreInput;<br />
unsigned char DEBOUNCE_EventStart;<br />
unsigned int DEBOUNCE_Integrator;<br />
volatile unsigned char DEBOUNCE_TimeFlag;

    void Key_Init(void)<br />
    {<br />
        DEBOUNCE_EventStart = ;<br />
        DEBOUNCE_Integrator = DEBOUNCE_ThreholdHigh / ;<br />
        DEBOUNCE_TimeFlag = ;

        DEBOUNCE_Open();<br />
        DEBOUNCE_IOCtl();<br />
        DEBOUNCE_PreInput = DEBOUNCE_Input;<br />
    }

    void Key_Scheduler(void)<br />
    {<br />
        if (DEBOUNCE_TimeFlag)<br />
        {<br />
            if (DEBOUNCE_EventStart)<br />
            {<br />
                if (DEBOUNCE_Input == )<br />
                {<br />
                    if (DEBOUNCE_Integrator-- == DEBOUNCE_ThreholdLow)<br />
                    {<br />
                        DEBOUNCE_Output = ;<br />
                        DEBOUNCE_PreInput = DEBOUNCE_Input;<br />
                        DEBOUNCE_EventStart = ;<br />
                        DEBOUNCE_Integrator = DEBOUNCE_ThreholdHigh / ;<br />
                    }<br />
                }<br />
                else                   //if (DEBOUNCE_Input == 1)<br />
                {<br />
                    if (DEBOUNCE_Integrator++ == DEBOUNCE_ThreholdHigh)<br />
                    {<br />
                        DEBOUNCE_Output = ;<br />
                        DEBOUNCE_PreInput = DEBOUNCE_Input;<br />
                        DEBOUNCE_EventStart = ;<br />
                        DEBOUNCE_Integrator = DEBOUNCE_ThreholdHigh / ;<br />
                    }<br />
                }<br />
            }<br />
            else if (DEBOUNCE_PreInput != DEBOUNCE_Input)<br />
            {<br />
                DEBOUNCE_EventStart = ;<br />
            }<br />
            DEBOUNCE_TimeFlag = ;<br />
        }<br />
    }</pre>
</div>
<p>　　TIMER module uses timer1 to generate interrupt per millisecond. and set "DEBOUNCE_TimeFlag" logic 1 in the timer1 interrupt service routine.</p>
<div>
<pre class="prettyprint linenums">void Timer1_Init(void)<br />
{<br />
    T1CON = 0x8010;<br />
    PR1 = 0x30D3;<br />
    IPC1SET = 0x5;<br />
    TMR1 = ;<br />
    IEC0SET = 0x10;<br />
    IFS0CLR = 0x10;<br />
}<br />
void Timer1_Write(unsigned int value)<br />
{<br />
    TMR1 = value &amp; 0xFFFF;<br />
}<br />
unsigned int Timer1_Read(void)<br />
{<br />
    return (TMR1 &amp; 0xFFFF);<br />
}</pre>
</div>
<p>　　Since interrupt will be used, the following sentence is enable interrupt with multi-vector mode.</p>
<div>
<pre class="prettyprint linenums">#define Mvec_Interrupt() INTCONSET = 0x1000; asm volatile("ei")</pre>
</div>
<p>　　The final is the implementation of main function and interrupt service and routine.</p>
<div>
<pre class="prettyprint linenums">#include &lt;xc.h&gt;<br />
#include "Led.h"<br />
#include "Key.h"<br />
#include "Timer.h"<br />
#include "Interrupt.h"<br />
#include &lt;sys/attribs.h&gt;<br />
#include "ConfigurationBits.h"

void __ISR(_TIMER_1_VECTOR,ipl1AUTO) Timer1_Handler(void)<br />
{<br />
    DEBOUNCE_TimeFlag = ;<br />
    Timer1_Write();<br />
    IFS0CLR = 0x10; // Clear flag<br />
 }

void main(void)<br />
{<br />
    Led_Init();<br />
    Key_Init();<br />
    Timer1_Init();<br />
    Mvec_Interrupt();

    while ()<br />
    {<br />
        Key_Scheduler();<br />
        Led_Scheduler();<br />
    }<br />
}</pre>
</div>
<p>　　The coding thing is done so far. we only need to compile and build it, then download it to PIC32MZ EC Starter Kit. You will get SW1 presse or release followed LED1 off or on. I bet it would run perfectly since the wonderful debounce algorithm.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k2658j.html">拥抱&period;NET Core，如何开发一个跨平台类库 &lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzze19.html">MFC操作excel</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o5gox9.html">【J-meter】变量加密之Bean shell使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2g45l8.html">memcache（三）内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8orx0e8.html">C&num;&colon;类和结构的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/49glj44q.html">tolua&period;cast的实用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1r4l9.html">java中的反射机制，以及如何通过反射获取一个类的构造方法 ，成员变量，方法，详细。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2x308.html">Scut游戏服务器免费开源框架--快速开发（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xk6z9.html">poj 2533 Longest Ordered Subsequence 最长递增子序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjeg579.html">使用Spring MVC 的表单控制器SimpleFormController</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zez059.html">Hadoop 3、Hadoop 分布式存储系统 HDFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mekrl0q.html">select可选择、同时可自行输入</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo6x2nq.html">201521123078 《Java程序设计》第12周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzd4oe8.html">整合springboot（app后台框架搭建四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k6ok69.html">AQS分析（AbstractQueuedSynchronizer）（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwz6oy8.html">初始MapReduce</a>
		</li>
						<li><a href="https://www.batexi.com/a/953pjne8.html">Java EE发展史</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4my21q.html">idea scala 报 with UTF-8 Please try specifying another one using the -encoding option</a>
		</li>
						<li><a href="https://www.batexi.com/a/q777kyeq.html">Tomcat8利用Redis配置Session共享</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jneen8.html">Android 电源管理 -- wakelock机制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4v6eeq.html">MVC 多级目录菜单</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2lv239.html">IOS&lowbar;画图 图片等比压缩 IOS&lowbar;UIImage</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2lnkx9.html">Android GPS定位 获取经纬度</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq16n128.html">C&plus;&plus;学习笔记21：文件系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4v2xeq.html">《深入浅出Node&period;js》第4章 异步编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/390x0rn9.html">http&lowbar;build&lowbar;query&lpar;&rpar;就是将一个数组转换成url 问号&quest;后面的参数字符串，并且会自动进行urlencode处理，及它的逆向函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9poo5kq.html">转： MySQL 赋予用户权限（grant &percnt;-远程和localhost-本地区别&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96wwvyq.html">poj3180 强连通</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq163p08.html">spl&lowbar;autoload&lowbar;register更改框架文件引用模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq163l08.html">App&lowbar;Offline&period;htm 功能</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
